
'=======================================================
'                                                      '
'            -------------------------                 '
'                  StringMap.inc                       '
'            -------------------------                 '
'                                                      '
'  This include file will let you manipulate strings.  ' 
'                                                      '
'                  By Andy1966.                        '
'                                                      '
'=======================================================


'==================================================
'                   Variables.                    '
'==================================================
int SMCount,SMNewCount
int SMStartDel,SMEndDel
int FirstTextPos,NextTextPos,LastTextPos,SMSearchString

type SMCharType
     int CharMatch
endtype

pointer SMChr
SMChr = new(SMCharType,1)
settype SMChr,SMCharType

type TStartType
     int TStart
endtype

pointer TSP 
TSP = new(TStartType,1)
settype TSP,TStartType

type SMaa
     istring aBlock[1024]
endtype

pointer SMab 
SMab = new(SMaa,1)
settype SMab,SMaa

istring SMNewString[5000]

'==================================================
'                   Subroutines.                  '
'==================================================
sub SMSearchText(string SMAstring,string SMDelimiter),int  

    SMBCount(SMAstring,SMDelimiter) 'SMCount text blocks so we can set each pointer size

	 delete SMChr
    SMChr = new(SMCharType,SMNewCount+2)
    settype SMChr,SMCharType

	 delete TSP
	 TSP = new(TStartType,SMNewCount+2)
	 settype TSP,TStartType

    delete SMab
    SMab = new(SMaa,SMNewCount+2)
    settype SMab,SMaa

	 istring SMString2[5000] = ""
	 SMStartDel = 0
	 SMEndDel   = 0

    SMCount = 0

    SMString2 = SMAstring

    if mid$(SMAstring,1,len(SMDelimiter)) <> SMDelimiter
       SMString2 = SMDelimiter + SMString2
       SMStartDel = 0
    else
       SMStartDel = 1
    endif

    if mid$(SMAstring,len(SMAstring)-(len(SMDelimiter)-1)) <> SMDelimiter
       SMEndDel = 0
    else
       SMEndDel = 1 
    endif  

	 for SMSearchString = 1 to len(SMString2)
		  if mid$(SMString2,SMSearchString,len(SMDelimiter)) = SMDelimiter
			  SMCount ++
		     #SMChr[SMCount].CharMatch = SMSearchString
        endif
	 next SMSearchString

	 for SMx = 1 to SMCount

		  int SMStartPos
		  int SMEndPos
		  int SMLength

		  if SMx = 1 and #SMChr[1].CharMatch <> 1
			  #SMab[SMx].aBlock = mid$(SMString2,1,#SMChr[1].CharMatch - 1)
		  else
           if SMx <> SMCount
			     SMStartPos = #SMChr[SMx].CharMatch + len(SMDelimiter)
			     SMEndPos   = #SMChr[SMx+1].CharMatch - 1
			     SMLength   = (SMEndPos - SMStartPos) + 1

              #TSP[SMx].Tstart = SMStartPos

              if mid$(SMString2,SMStartPos,SMLength) <> ""
                 #SMab[SMx].aBlock = mid$(SMString2,SMStartPos,SMLength)
              endif
           else
			     SMStartPos = #SMChr[SMCount].CharMatch + len(SMDelimiter)
			     SMEndPos   = #SMChr[SMCount].CharMatch + len(SMDelimiter) + len(SMString2)
			     SMLength   = (SMEndPos - SMStartPos) + 1

              #TSP[SMx].Tstart = SMStartPos

              if mid$(SMString2,SMStartPos,SMLength) <> ""
                 SMCount ++ 
                 #SMab[SMCount].aBlock = mid$(SMString2,SMStartPos,SMLength)
              endif
              breakfor
           endif

		  endif

	 next SMx

	 SMNewCount = 0

	 for SMx = 1 to SMCount
        if SMStartDel = 0  
           #TSP[SMx].TStart = #TSP[SMx].TStart - len(SMDelimiter)
        endif
 
		  if #SMab[SMx].aBlock <> ""
			  SMNewCount ++
			  #SMab[SMNewCount].aBlock  = #SMab[SMx].aBlock
		  endif
	 next SMx

return SMNewCount
endsub

sub ReplaceDelimiter(string SMAstring,string SMDelimiter,string SMNewDelimiter),string

    istring SMReturnIstring[5000]

    SMSearchText(SMAstring,SMDelimiter)

    SMNewString = ""

    for SMx = 1 to SMNewCount
        SMNewString = SMNewString + SMNewDelimiter + #SMab[SMx].aBlock
    next SMx

    SMNewString = SMNewString + SMNewDelimiter

    if mid$(SMAstring,1,len(SMDelimiter)) <> SMDelimiter
       SMNewString = mid$(SMNewString,len(SMNewDelimiter)+1,len(SMNewString))
    endif

    if mid$(SMAstring,(len(SMAstring)-len(SMDelimiter)+1),len(SMAstring)) <> SMDelimiter
       SMNewString = mid$(SMNewString,1,(len(SMNewString)-len(SMNewDelimiter)))
    endif

    SMReturnIstring = SMNewString
return SMReturnIstring
endsub

sub CountBlocks(string SMAstring,string SMDelimiter),int
	 SMCount = 0
	 SMNewCount = SMSearchText(SMAstring,SMDelimiter)
return SMNewCount
endsub

sub GetFirstText(string SMAstring,string SMDelimiter),string 
    istring SMReturnIstring[5000] 
	 SMCount = 0
	 SMSearchText(SMAstring,SMDelimiter)
    FirstTextPos    = #TSP[1].TStart
    SMReturnIstring = #SMab[1].aBlock 
return SMReturnIstring 
endsub

sub GetNextText(string SMAstring,string SMDelimiter,int SMBlockCount),string 
    istring SMReturnIstring[5000]  
	 SMCount = 0
	 SMSearchText(SMAstring,SMDelimiter)
    NextTextPos     = #TSP[SMBlockCount].TStart
    SMReturnIstring = #SMab[SMBlockCount].aBlock 
return SMReturnIstring
endsub

sub GetLastText(string SMAstring,string SMDelimiter),string  
    istring SMReturnIstring[5000]  
	 SMCount = 0
	 SMSearchText(SMAstring,SMDelimiter)
    LastTextPos     = #TSP[SMNewCount].TStart
    SMReturnIstring = #SMab[SMNewCount].aBlock 
return SMReturnIstring
endsub

sub SMBCount(string SMAstring,string SMDelimiter),int
    istring SMString2[5000]
    SMString2 = SMAstring

	 for SMSearchString = 1 to len(SMString2)
		  if mid$(SMString2,SMSearchString,len(SMDelimiter)) = SMDelimiter
			  SMCount ++
        endif
	 next SMSearchString

    if mid$(SMString2,1,len(SMDelimiter)) <> SMDelimiter
       SMString2 = SMDelimiter + SMString2
       SMCount ++
    endif

    if mid$(SMString2,len(SMString2)-(len(SMDelimiter)-1)) = SMDelimiter
       SMCount -- 
    endif

    SMNewCount = 0
    SMNewCount = SMCount
return SMNewCount
endsub

sub InstrAll(string SMAstring,string SMSearchInText),int
    int InstrACnt = 0
    int InstrAPos = 0
    SMString2 = SMAstring
	 for SMSearchString = 1 to len(SMString2)
		  if mid$(SMString2,SMSearchString,len(SMSearchInText)) = SMSearchInText
           InstrACnt ++
        endif
	 next SMSearchString
return InstrACnt
endsub

sub InstrX(string SMAstring,string SMSearchInText,int SMInstance),int
    int InstrCnt = 0
    int InstrPos = 0
    SMString2 = SMAstring
	 for SMSearchString = 1 to len(SMString2)
		  if mid$(SMString2,SMSearchString,len(SMSearchInText)) = SMSearchInText
           InstrCnt ++
           if InstrCnt = SMInstance then return SMSearchString
        endif
	 next SMSearchString
return 0
endsub

sub ReplaceString(string SMAstringIn,string SMSearchInText,int SMInstance,string SMANewText),string
    istring SMReturnIstring[5000]  
    istring SMBeforeChange[5000]
    istring SMAfterChange[5000]

    int InstrCCnt = InstrX(SMAstringIn,SMSearchInText,SMInstance)

    if InstrCCnt = 0 
       SMReturnIstring = SMAstringIn
       return SMReturnIstring
    endif 

    SMBeforeChange = mid$(SMAstringIn,1,(SMSearchString-1))
    SMAfterChange  = mid$(SMAstringIn,(SMSearchString+len(SMSearchInText)),len(SMAstringIn))
    SMReturnIstring = SMBeforeChange + SMANewText + SMAfterChange

return SMReturnIstring
endsub

sub ReplaceAllStrings(string SMAstring,string SMSearchInText,string SMANewText),string
    istring SMReturnIstring[5000]  

    SMReturnIstring = SMAstring

    label looproundagain 
    int InstrBCnt = InstrAll(SMReturnIstring,SMSearchInText)

    if InstrBCnt = 0 
       SMReturnIstring = SMAstring
       return SMReturnIstring
    endif    

    for SMx = 1 to InstrBCnt 
        SMReturnIstring = ReplaceString(SMReturnIstring,SMSearchInText,1,SMANewText)
    next SMx

return SMReturnIstring
endsub

sub EndStringMap(),int
	 delete SMChr
	 delete TSP
    delete SMab
return 0
endsub
